#include "keyboard.h"

int rows [] = {ROW1, ROW2, ROW3, ROW4};
int cols [] = {COL1, COL2, COL3};

int getkey()
{
   PORTD |= (1 << ROW2) | (1 << ROW1) | (1 << ROW3) | (1 << ROW4);  // activam rezistenta de pull-up
  
   DDRD |= (1 << COL1) | (1 << COL2) | (1 << COL3);
   int i, ret = -1;
   
   for (i = 0; i < 3; i++) {
      switch(i) {
	 case 0: {
	  DDRD |= (1 << COL1);
	  
	  if (!(PIND & (1 << ROW1)))
	     ret = 1;
	  if (!(PIND & (1 << ROW2)))
	     ret = 0;
	  if (!(PIND & (1 << ROW3)))
	     ret = DIEZ;
	  if (!(PIND & (1 << ROW4)))
	     ret = ASTERISK;
	  
	  DDRD &= ~(1<< COL1);
	  return ret;
	 }
	 case 1: {
	  DDRD |= 1 << COL2;  
	  
	  if (!(PIND & (1 << ROW1)))
	     ret = 2;
	  if (!(PIND & (1 << ROW2)))
	     ret = 5;
	  if (!(PIND & (1 << ROW3)))
	     ret = 8;
	  if (!(PIND & (1 << ROW4)))
	     ret = 4;
	  
	  DDRD &= ~(1 << COL2);
	  return ret;
	 }
	 case 3: {
	  DDRD |= 1 << COL3;  
	  
	  if (!(PIND & (1 << ROW1)))
	     ret = 3;
	  if (!(PIND & (1 << ROW2)))
	     ret = 6;
	  if (!(PIND & (1 << ROW3)))
	     ret = 9;
	  if (!(PIND & (1 << ROW4)))
	     ret = 7;
	  
	  DDRD &= ~(1<< COL3);
	  return ret;
	 }
      }
   }
   return ret;
}

char get_letter(int key, int count)
{
   switch(key) {
      case 2: {
	 switch(count) {
	    case 1: return 'a';
	    case 2: return 'b';
	    case 3: return 'c';
	 }
      }
      case 3: {
	 switch(count) {
	    case 1: return 'd';
	    case 2: return 'e';
	    case 3: return 'f';
	 }
      }
      case 4: {
	 switch(count) {
	    case 1: return 'g';
	    case 2: return 'h';
	    case 3: return 'i';
	 }
      }
      case 5: {
	 switch(count) {
	    case 1: return 'j';
	    case 2: return 'k';
	    case 3: return 'l';
	 }
      }
      case 6: {
	 switch(count) {
	    case 1: return 'm';
	    case 2: return 'n';
	    case 3: return 'o';
	 }
      }
      case 7: {
	 switch(count) {
	    case 1: return 'p';
	    case 2: return 'r';
	    case 3: return 's';
	 }
      }
      case 8: {
	 switch(count) {
	    case 1: return 't';
	    case 2: return 'u';
	    case 3: return 'v';
	 }
      }
      case 9: {
	 switch(count) {
	    case 1: return 'x';
	    case 2: return 'y';
	    case 3: return 'z';
	 }
      }
   }
}

