/************************************************************************ *********
 * Proiectarea cu Microprocesoare
 * Laboratorul 1
 * Digital I/O
 *********************************************************************************/

#include <avr/io.h>
#include <avr/interrupt.h>
#define F_CPU 16000000
#include <util/delay.h>

#include <string.h>

#include "lcd.h"
#include "keyboard.h"
#include "game.h"

int main()
{
   DDRD |= (1 << PD7);   // pinul corespunzator led-ului USER este output
   LCD_init();
   LCD_waitNotBusy();
   
   main_menu();
  

   while(1);
   
   return 0;
}
